Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0007754opensim[REGION] OpenSim Corepublic2015-11-23 19:322016-04-01 10:02
Reportermewtwo0641 
Assigned Tomewtwo0641 
PrioritynormalSeverityminorReproducibilityalways
StatusresolvedResolutionfixed 
PlatformOSOS Version
Product Versionmaster (dev code) 
Target VersionFixed in Versionmaster (dev code) 
Summary0007754: Duplicate chat output from agents and objects
DescriptionAs of master there are duplicate chat output from agents and objects.

This seems to be directly related to the number of regions that are running on the simulator. (i.e. 1 region results in 1 line of chat (as perceived normal), 2 regions result in 2 duplicates of the chat, 3 regions result in 3 duplicates of the chat, etc.)

This affects agents as well as objects that output chat. (My tested object used llSay().)

Steps To Reproduce1. Have a setup with more than one region (I used 3 regions in Standalone mode)

2. Say something in chat
   a. Observe that there are duplicates of what was said depending on how many regions are set up
Additional InformationGit bisect info:

$ git bisect bad
e15ebc091f19634d0d50d63b0dd6bc7179a09ee5 is the first bad commit
commit e15ebc091f19634d0d50d63b0dd6bc7179a09ee5
Author: UbitUmarov <ajlduarte@sapo.pt>
Date: Tue Nov 17 01:31:06 2015 +0000

     bug fix: improve chat to child avatars. Still not good because of low resolution of child position updates

:040000 040000 8860932a9666a6c5c69f275a89053de227f4f64d e6a276bb239e1624de007cd87e289f8dbbd2e864 M OpenSim
TagsNo tags attached.
Git Revision or version number
Run Mode Standalone (Multiple Regions)
Physics EngineBulletSim
Environment.NET / Windows64
Mono VersionNone
ViewerAll
Attached Filesjpg file icon 2015-11-24-Openvue-Multiple-Chat-on-Channel-0.jpg [^] (278,165 bytes) 2015-11-24 06:59

- Relationships

-  Notes
(0029625)
UbitUmarov (administrator)
2015-11-24 04:54

can you try with the new code on master?
(0029627)
aiaustin (developer)
2015-11-24 06:38
edited on: 2015-11-24 07:00

I also just spotted this on opensim-0.9.0-91-g5e4b166.zip. I am getting chat and shout showing once for current region and once for each adjacent region... so 9 where a region is surrounded. This shows for avatar chat and for objects which output to channel 0.

I will update to the latest version with the fix and report back. Pity as I just updated everything to a version from earlier today.

I am getting instant (no grey screen and message) crashes (Firestorm 4.7.5) also while testing that on Openvue, AiLand and our OSGrid addon regions which might be related as it occurs just after the chat messages are listed in the viewer - not TPing at the time.

On OSGrid I am getting grey screen of death crashes when TPing/moving between regions on same grid that are up and that I can immediately afterwards log into. May be related or not. Still separating these issues out.

(0029628)
UbitUmarov (administrator)
2015-11-24 06:53

I also just added new code that may be related to the crashes on teleports
(0029629)
aiaustin (developer)
2015-11-24 06:54
edited on: 2015-11-24 06:58

On opensim-0.9.0-95-g08d061d.zip I still get a repeat of chat from avatars and from objects talking on channel 0 once for current region and once for each adjacent region. This is for chat, shout and whisper.

See attached image 2015-11-24-Openvue-Multiple-Chat-on-Channel-0.jpg

(0029630)
UbitUmarov (administrator)
2015-11-24 07:14

yeap bad fix: added a check just for chats to a specific target, new try pushed
(0029631)
aiaustin (developer)
2015-11-24 07:28
edited on: 2015-11-24 07:28

Tested with one avatar on opensim-0.9.0-96-ga0c3297.zip on a region on AiLand grid that has two adjacent regions, and that was previously showing three copies of the chat messages, and there are no repeat chat message now.

I kind of have a worry that some underlying change must have triggered this in the first place and that much more work than necessary is going on in multi-region settings. Is this patch just masking an underlying inefficiency that has crept in Ubit?

(0029632)
UbitUmarov (administrator)
2015-11-24 07:48

Opensim didn't sent chat across borders. New avination code does send in some cases. Since we never use more than one scene per instance, we never noticed this bug.
This chat across borders still has problems, but those are on a different part of code (child position updates)
(0029633)
aiaustin (developer)
2015-11-24 08:13

Okay, thanks for the explanation... always useful to know when testing these changes.

Isn't that a worrying complexity when there can be many adjacent regions (up to 8) in the same OpenSim.exe instance? I was seeing 9 repeats of chat by objects and avatars, and although that is supressed by the conditional you added, presumably a lot extra is now going on just to pass text chat across the region border?
(0029658)
mewtwo0641 (reporter)
2015-11-24 22:42
edited on: 2015-11-24 22:45

Testing latest master the duplicate chat seems to be gone (at least for me)

For testing I've used an 11 region standalone (non grid, non hypergrid) in a configuration like this:

         [ ]
      [ ][ ][ ]
      [ ][ ][ ][ ][ ]
   [ ] [ ]

Normal, Shout, and Whisper chat work as expected, with normal limits (20m, 100m, 10m, respectively) when recipients are in the same region; however when chatting across region borders I've noticed some oddness.

Take this scenario for instance where the X's represent an agent in one region and an agent in an adjacent region (Near the edge of the border and near each other for the purpose of chat testing):

         [ ]
      [ ][X][X]
      [ ][ ][ ][ ][ ]
   [ ] [ ]

In this instance I found that Normal chat range is about half that what it is supposed to be (10m instead of 20m), Whisper doesn't travel at all across the border, Shouts seem to work at the normal 100m limit


Another example is chatting across regions diagonal to one another. Here we have two agents where the X's are as close to one another as possible with out crossing over the borders in the NE and SW of the two regions

         [ ]
      [ ][ ][ ]
      [X][ ][ ][ ][ ]
   [X] [ ]

This scenario yields similar results but the Normal chat distance is even less that of the previous example (5m this time before the other agent can hear the chat), Whisper doesn't travel in this case either, and Shout works as per normal chat limits.

Not sure if this cross border chat quirkiness is by design or not but just thought I'd point it out.

Note: These diagrams might look a bit off due to font differences in the note editor and the actual post but hopefully it's enough to convey the example.

(0029659)
UbitUmarov (administrator)
2015-11-24 23:02

as I said, chat across borders still has issues due to slow and low resolution postion updates of avatars on the other region
(0029660)
mewtwo0641 (reporter)
2015-11-25 00:13

Ah ok, apologies; I think I missed that :)
(0030137)
mewtwo0641 (reporter)
2016-04-01 10:02

Haven't seen this issue for a while; seems fixed by master.

- Issue History
Date Modified Username Field Change
2015-11-23 19:32 mewtwo0641 New Issue
2015-11-24 04:54 UbitUmarov Note Added: 0029625
2015-11-24 06:38 aiaustin Note Added: 0029627
2015-11-24 06:38 aiaustin Note Edited: 0029627 View Revisions
2015-11-24 06:39 aiaustin Note Edited: 0029627 View Revisions
2015-11-24 06:53 UbitUmarov Note Added: 0029628
2015-11-24 06:54 aiaustin Note Added: 0029629
2015-11-24 06:58 aiaustin Note Edited: 0029629 View Revisions
2015-11-24 06:59 aiaustin File Added: 2015-11-24-Openvue-Multiple-Chat-on-Channel-0.jpg
2015-11-24 07:00 aiaustin Note Edited: 0029627 View Revisions
2015-11-24 07:14 UbitUmarov Note Added: 0029630
2015-11-24 07:28 aiaustin Note Added: 0029631
2015-11-24 07:28 aiaustin Note Edited: 0029631 View Revisions
2015-11-24 07:48 UbitUmarov Note Added: 0029632
2015-11-24 08:13 aiaustin Note Added: 0029633
2015-11-24 22:42 mewtwo0641 Note Added: 0029658
2015-11-24 22:45 mewtwo0641 Note Edited: 0029658 View Revisions
2015-11-24 23:02 UbitUmarov Note Added: 0029659
2015-11-25 00:13 mewtwo0641 Note Added: 0029660
2016-04-01 10:02 mewtwo0641 Note Added: 0030137
2016-04-01 10:02 mewtwo0641 Status new => resolved
2016-04-01 10:02 mewtwo0641 Fixed in Version => master (dev code)
2016-04-01 10:02 mewtwo0641 Resolution open => fixed
2016-04-01 10:02 mewtwo0641 Assigned To => mewtwo0641


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker